#property  copyright "ANG3110@latchess.com"
//----------------------------------------
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Yellow


//-------------------------------
extern int hrf = 4;
extern int hrma = 6;
extern int days = 2;
//-----------------------------------------
double ak[],bk[],fx[],w,ak0,ss,sc,sk,dfx[];
int T,sm,k;
double ma[],dc[];
int pma;

//----------------------------------------------------
//
//----------------------------------------------------
//
//
//
//
//

#define pi 3.1415926535897932384626433832795

int init()
{
   IndicatorBuffers(5);
      SetIndexBuffer(0,fx);
      SetIndexBuffer(1,ma);
      SetIndexBuffer(2,ak);
      SetIndexBuffer(3,bk);
      SetIndexBuffer(4,dc);

      pma = hrma*60/Period();
      T   = days*1440/Period(); 
      w   = 2*pi/T;     
      k   = T/(hrf*60/Period());
   return(0);
}

//----------------------------------------------------
//
//----------------------------------------------------
//
//
//
//
//

int start()
{
   int n,i,cbi=Bars-IndicatorCounted()+1;

   //
   //
   //
   //
   //
   
   for(i=cbi; i>=0; i--)
   {
      ma[i] = iMA(NULL,0,pma,0,MODE_SMMA,PRICE_MEDIAN,i);
      dc[i] = Close[i]-ma[i];
   }
   
   //
   //
   //
   //
   //

      ak0=0.0;
         for (n=k; n>=0; n--)
         {
            sc=0.0;
            ss=0.0;  
               for (i=T-1; i>=0; i--)
                  if (n==0) ak0+=dc[i];
                  else
                     {
                        sc += dc[i]*MathCos(n*i*w);
                        ss += dc[i]*MathSin(n*i*w);
                     }
            ak[n]=sc*2/T;
            bk[n]=ss*2/T;
         }
      ak0=ak0/T; 
         for (i=T-1; i>=0; i--)
         {
            sk = 0.0;
            for (n=k; n>=1; n--)
               sk   += ak[n]*MathCos(n*i*w)+bk[n]*MathSin(n*i*w);
               fx[i] = ak0+sk+ma[i];  
         } 
   
   //
   //
   //
   //
   //
   
   return(0);
}